function HKCTableFrame_DrawTable(db, offset)
	if ( not offset ) then
		offset = 0;
	end

	local record, i;

	for i = 1, 20 do
		record = db[i + offset];
		if ( record ) then
			_G["HKCTableFrameListItem"..i.."Time"]:SetText(date("%c", record[1]));

			if ( record[2] == 0 ) then
				_G["HKCTableFrameListItem"..i.."Victor"]:SetText(HKC_HORDE);
			elseif ( record[2] == 1 ) then
				_G["HKCTableFrameListItem"..i.."Victor"]:SetText(HKC_ALLIANCE);
			else
				_G["HKCTableFrameListItem"..i.."Victor"]:SetText("|c00999999-|r");
			end

			local kbRank, damageRank, healingRank, joinedLate = "", "", "", "";
			if ( record[13] ) then
				kbRank, damageRank, healingRank, joinedLate = HKC_SplitItem13(record[13], true);
			end

			if ( joinedLate == "" ) then
				_G["HKCTableFrameListItem"..i.."Duration"]:SetText("|c0000ffff"..record[4].."|r m");
			else
				_G["HKCTableFrameListItem"..i.."Duration"]:SetText("|c0000ffff"..record[4].."|r m*");
			end
			_G["HKCTableFrameListItem"..i.."Gained"]:SetText("|c0000ffff"..record[3].."|r");

			if ( record[5] > 0 ) then
				_G["HKCTableFrameListItem"..i.."PremadeA"]:SetText(record[5]);
			else
				_G["HKCTableFrameListItem"..i.."PremadeA"]:SetText("|c00999999-|r");
			end
			if ( record[6] > 0 ) then
				_G["HKCTableFrameListItem"..i.."PremadeH"]:SetText(record[6]);
			else
				_G["HKCTableFrameListItem"..i.."PremadeH"]:SetText("|c00999999-|r");
			end

			if ( record[4] <= 5 and record[7] == 0 and record[8] == 0 ) then
				-- was not in BG long enough to determine AFKers
				_G["HKCTableFrameListItem"..i.."AFKA"]:SetText("|c00999999-|r");
				_G["HKCTableFrameListItem"..i.."AFKH"]:SetText("|c00999999-|r");
			else
				if ( record[7] > 0 ) then
					_G["HKCTableFrameListItem"..i.."AFKA"]:SetText("|c00ffffff"..record[7].."|r");
				else
					_G["HKCTableFrameListItem"..i.."AFKA"]:SetText("|c00999999"..record[7].."|r");
				end
				if ( record[8] > 0 ) then
					_G["HKCTableFrameListItem"..i.."AFKH"]:SetText("|c00ffffff"..record[8].."|r");
				else
					_G["HKCTableFrameListItem"..i.."AFKH"]:SetText("|c00999999"..record[8].."|r");
				end
			end

			if ( record[14] ) then
				if ( record[14] >= 0 ) then
					_G["HKCTableFrameListItem"..i.."AScore"]:SetText(record[14]);
				else
					_G["HKCTableFrameListItem"..i.."AScore"]:SetText("?");
				end
				if ( record[15] >= 0 ) then
					_G["HKCTableFrameListItem"..i.."HScore"]:SetText(record[15]);
				else
					_G["HKCTableFrameListItem"..i.."HScore"]:SetText("?");
				end
			else
				_G["HKCTableFrameListItem"..i.."AScore"]:SetText("");
				_G["HKCTableFrameListItem"..i.."HScore"]:SetText("");
			end

			_G["HKCTableFrameListItem"..i.."KBs"]:SetText("|c00ffff00"..record[9].."|r "..kbRank);
			_G["HKCTableFrameListItem"..i.."Damage"]:SetText("|c00ffff00"..record[10].."|r "..damageRank);
			_G["HKCTableFrameListItem"..i.."Healing"]:SetText("|c00ffff00"..record[11].."|r "..healingRank);
			_G["HKCTableFrameListItem"..i.."Character"]:SetText("|c0000ff00"..record[12].."|r");
		else
			_G["HKCTableFrameListItem"..i.."Time"]:SetText("");
			_G["HKCTableFrameListItem"..i.."Victor"]:SetText("");
			_G["HKCTableFrameListItem"..i.."Duration"]:SetText("");
			_G["HKCTableFrameListItem"..i.."Gained"]:SetText("");
			_G["HKCTableFrameListItem"..i.."AScore"]:SetText("");
			_G["HKCTableFrameListItem"..i.."HScore"]:SetText("");
			_G["HKCTableFrameListItem"..i.."PremadeA"]:SetText("");
			_G["HKCTableFrameListItem"..i.."PremadeH"]:SetText("");
			_G["HKCTableFrameListItem"..i.."AFKA"]:SetText("");
			_G["HKCTableFrameListItem"..i.."AFKH"]:SetText("");
			_G["HKCTableFrameListItem"..i.."KBs"]:SetText("");
			_G["HKCTableFrameListItem"..i.."Damage"]:SetText("");
			_G["HKCTableFrameListItem"..i.."Healing"]:SetText("");
			_G["HKCTableFrameListItem"..i.."Character"]:SetText("");
		end
	end
end

function HKCTableFrame_GetAverages()
	local record;
	local records, afkRecords, hordeWins, allianceWins, duration, gained, premadeA, premadeH, afkA, afkH, kbs, damage, healing = 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0;

	for _, record in ipairs(HKC_DB) do
		if ( record[2] == 0 ) then
			hordeWins = hordeWins + 1;
		elseif ( record[2] == 1 ) then
			allianceWins = allianceWins + 1;
		end

		duration = duration + record[4];
		gained = gained + record[3];
		premadeA = premadeA + record[5];
		premadeH = premadeH + record[6];
		if ( record[7] > 0 or record[8] > 0 or record[4] > 5 ) then
			afkA = afkA + record[7];
			afkH = afkH + record[8];
			afkRecords = afkRecords + 1;
		end
		kbs = kbs + record[9];
		damage = damage + record[10];
		healing = healing + record[11];

		records = records + 1;
	end

	if ( records == 0 ) then
		HKCTableFrameAverages:Hide();
		HKCTableFrameHonorPerHour:Hide();
		HKCTableFrameWinPercent:Hide();
		return
	else
		HKCTableFrameAverages:Show();
		HKCTableFrameHonorPerHour:Show();
		HKCTableFrameWinPercent:Show();
	end

	-- average and trim decimal length
	duration = duration / records;
	duration = duration - (duration % .1);
	gained = gained / records;
	gained = gained - (gained % 1 );
	premadeA = premadeA / records;
	premadeA = premadeA - (premadeA % .1);
	premadeH = premadeH / records;
	premadeH = premadeH - (premadeH % .1);
	if ( afkRecords > 0 ) then
		afkA = afkA / afkRecords;
		afkA = afkA - (afkA % .1);
		afkH = afkH / afkRecords;
		afkH = afkH - (afkH % .1);
	end
	kbs = kbs / records;
	kbs = kbs - (kbs % .1);
	damage = damage / records;
	damage = damage - (damage % 1);
	healing = healing / records;
	healing = healing - (healing % 1);

	local incompleteGames = records - allianceWins - hordeWins;
	HKCTableFrameAveragesVictor:SetText("|c0000adef"..allianceWins.."|r/|c00ff1919"..hordeWins.."|r/|c00999999"..incompleteGames.."|r");

	local alliancePct, hordePct, incompletePct = HKC_GetWinPercentiles(allianceWins, hordeWins, incompleteGames);
	HKCTableFrameWinPercent:SetText("|c0000adef"..alliancePct.."%|r/|c00ff1919"..hordePct.."%|r/|c00999999"..incompletePct.."%|r");

	HKCTableFrameAveragesDuration:SetText("|c0000ffff"..duration.."|r m");
	HKCTableFrameAveragesGained:SetText("|c0000ffff"..gained.."|r");
	local x = gained / (duration / 60);
	x = x - (x % 1);
	HKCTableFrameHonorPerHour:SetText("|c0000ffff"..x.."|r "..HONOR.."/".."Hr");

	HKCTableFrameAveragesPremadeA:SetText(premadeA);
	HKCTableFrameAveragesPremadeH:SetText(premadeH);

	if ( afkRecords > 0 ) then
		HKCTableFrameAveragesAFKA:SetText(afkA);
		HKCTableFrameAveragesAFKH:SetText(afkH);
	else
		HKCTableFrameAveragesAFKA:SetText("|c00999999-|r");
		HKCTableFrameAveragesAFKH:SetText("|c00999999-|r");
	end

	HKCTableFrameAveragesKBs:SetText("|c00ffff00"..kbs.."|r");
	HKCTableFrameAveragesDamage:SetText("|c00ffff00"..damage.."|r");
	HKCTableFrameAveragesHealing:SetText("|c00ffff00"..healing.."|r");
end

function HKC_CheckFilters(record)
	local min, max;

	if ( HKCFilterFrameIncompletesCheckButton:GetChecked() and record[2] == 2 ) then
		return false;
	end
	if ( HKCFilterFrameAllianceWinsCheckButton:GetChecked() and record[2] == 1 ) then
		return false;
	end
	if ( HKCFilterFrameHordeWinsCheckButton:GetChecked() and record[2] == 0 ) then
		return false;
	end
	if ( HKCFilterFrameOtherCharactersCheckButton:GetChecked() and record[12] ~= HKC_PlayerName ) then
		return false;
	end
	if ( HKCFilterFrameDurationRangeCheckButton:GetChecked() ) then
		min = HKCFilterFrameMinDurationEditBox:GetNumber();
		max = HKCFilterFrameMaxDurationEditBox:GetNumber();
		if ( record[4] < min or record[4] > max ) then
			return false;
		end
	end
	if ( HKCFilterFrameHonorRangeCheckButton:GetChecked() ) then
		min = HKCFilterFrameMinHonorEditBox:GetNumber();
		max = HKCFilterFrameMaxHonorEditBox:GetNumber();
		if ( record[3] < min or record[3] > max ) then
			return false;
		end
	end
	if ( HKCFilterFramePremadeARangeCheckButton:GetChecked() ) then
		min = HKCFilterFramePremadeAMinEditBox:GetNumber();
		max = HKCFilterFramePremadeAMaxEditBox:GetNumber();
		if ( record[5] < min or record[5] > max ) then
			return false;
		end
	end
	if ( HKCFilterFramePremadeHRangeCheckButton:GetChecked() ) then
		min = HKCFilterFramePremadeHMinEditBox:GetNumber();
		max = HKCFilterFramePremadeHMaxEditBox:GetNumber();
		if ( record[6] < min or record[6] > max ) then
			return false;
		end
	end
	if ( HKCFilterFrameAFKARangeCheckButton:GetChecked() ) then
		min = HKCFilterFrameAFKAMinEditBox:GetNumber();
		max = HKCFilterFrameAFKAMaxEditBox:GetNumber();
		if ( record[7] < min or record[7] > max ) then
			return false;
		end
	end
	if ( HKCFilterFrameAFKHRangeCheckButton:GetChecked() ) then
		min = HKCFilterFrameAFKHMinEditBox:GetNumber();
		max = HKCFilterFrameAFKHMaxEditBox:GetNumber();
		if ( record[8] < min or record[8] > max ) then
			return false;
		end
	end
	if ( HKCFilterFrameMinKBsCheckButton:GetChecked() and record[9] < HKCFilterFrameMinKBsEditBox:GetNumber() ) then
		return false;
	end
	if ( HKCFilterFrameMinDamageCheckButton:GetChecked() and record[10] < HKCFilterFrameMinDamageEditBox:GetNumber() ) then
		return false;
	end
	if ( HKCFilterFrameMinHealingCheckButton:GetChecked() and record[11] < HKCFilterFrameMinHealingEditBox:GetNumber() ) then
		return false;
	end
	if ( HKCFilterFrameTimeOfDayCheckButton:GetChecked() ) then
		min = HKCFilterFrameTimeOfDayMinEditBox:GetNumber();
		max = HKCFilterFrameTimeOfDayMaxEditBox:GetNumber();

		local hour = date("%H", record[1]);
		hour = tonumber(hour);

		if ( hour < min or hour > max ) then
			return false;
		end
	end
	if (	HKCFilterFrameJoinedLateCheckButton:GetChecked()
		or HKCFilterFrameKBRankCheckButton:GetChecked()
		or HKCFilterFrameDamageRankCheckButton:GetChecked()
		or HKCFilterFrameHealingRankCheckButton:GetChecked()
	) then
		local kbRank, damageRank, healingRank, joinedLate = HKC_SplitItem13(record[13]);

		if ( HKCFilterFrameJoinedLateCheckButton:GetChecked() and joinedLate ) then
			return false;
		end
		if ( HKCFilterFrameKBRankCheckButton:GetChecked() ) then
			min = HKCFilterFrameKBRankMinEditBox:GetNumber();
			max = HKCFilterFrameKBRankMaxEditBox:GetNumber();

			if ( kbRank < min or kbRank > max ) then
				return false;
			end
		end
		if ( HKCFilterFrameDamageRankCheckButton:GetChecked() ) then
			min = HKCFilterFrameDamageRankMinEditBox:GetNumber();
			max = HKCFilterFrameDamageRankMaxEditBox:GetNumber();

			if ( damageRank < min or damageRank > max ) then
				return false;
			end
		end
		if ( HKCFilterFrameHealingRankCheckButton:GetChecked() ) then
			min = HKCFilterFrameHealingRankMinEditBox:GetNumber();
			max = HKCFilterFrameHealingRankMaxEditBox:GetNumber();

			if ( healingRank < min or healingRank > max ) then
				return false;
			end
		end
	end
	return true;
end

function HKCTableFrame_UpdateDB()
	-- create an array of references to every record so we can sort and filter
	HKC_DB = {};

	local bg, bracket;
	bg = HKC_BGHISTORY_LABELS[HKC_BGHistory_Selected];
	if ( HKC_BGHistory[HKC_Server][bg] ) then
		if ( HKC_BGHISTORY_BRACKET_LABELS and HKC_BGHISTORY_BRACKET_LABELS[HKC_BGHistoryBracket_Selected] ) then
			bracket = HKC_BGHISTORY_BRACKET_LABELS[HKC_BGHistoryBracket_Selected];
		end
	end

	if ( not bg or not bracket ) then
		return
	end

	-- time frame
	local startDate, endDate, startDateTable, endDateTable;
	if ( not HKCTableFrameAllRecordsCheckButton:GetChecked() ) then
		startDateTable = {
			month = HKCTableFrameStartMonthEditBox:GetNumber(),
			day = HKCTableFrameStartDayEditBox:GetNumber(),
			year = HKCTableFrameStartYearEditBox:GetNumber() + 2000,
			hour = HKCTableFrameStartHourEditBox:GetNumber()
		};
		endDateTable = {
			month = HKCTableFrameEndMonthEditBox:GetNumber(),
			day = HKCTableFrameEndDayEditBox:GetNumber(),
			year = HKCTableFrameEndYearEditBox:GetNumber() + 2000,
			hour = HKCTableFrameEndHourEditBox:GetNumber()
		};
		startDate = time(startDateTable);
		endDate = time(endDateTable);
		if ( not startDate ) then
			startDate = 0;
		end
		if ( not endDate ) then
			endDate = 9999999999;
		end
	end

	-- get record references from HKC_BGHistory
	local record;
	local records = 0;
	for _, record in ipairs(HKC_BGHistory[HKC_Server][bg][bracket]) do

		if ( HKCTableFrameAllRecordsCheckButton:GetChecked() ) then
			-- all records
			if ( HKC_CheckFilters(record) ) then
				table.insert(HKC_DB, record);
			end
			records = records + 1;
		else
			-- time frame
			if ( record[1] > startDate and record[1] < endDate ) then
				if ( HKC_CheckFilters(record) ) then
					table.insert(HKC_DB, record);
				end
				records = records + 1;
			end
		end

	end

	-- print records displayed
	HKCTableFrameRecords:SetText(table.getn(HKC_DB)..HKC_OF..records);

	-- set averages
	HKCTableFrame_GetAverages();

	HKC_LastSort = 0;
	HKCTableFrame_Sort(1);	-- sort by date, descending
end

function HKCTableFrame_OnShow()

	local bg, bracket;
	bg = HKC_BGHISTORY_LABELS[HKC_BGHistory_Selected];
	if ( HKC_BGHistory[HKC_Server][bg] ) then
		if ( HKC_BGHISTORY_BRACKET_LABELS and HKC_BGHISTORY_BRACKET_LABELS[HKC_BGHistoryBracket_Selected] ) then
			bracket = HKC_BGHISTORY_BRACKET_LABELS[HKC_BGHistoryBracket_Selected];
		end
	end

	if ( not bg or not bracket ) then
		return
	end

	local ref = HKC_BGHistory[HKC_Server][bg][bracket];

	HKCTableFrameTitle:SetText(bg.." "..bracket.." "..HKC_BRACKET_LABEL);

	HKCTableFrameStartMonthEditBox:SetText( date("%m", ref[1][1]) );
	HKCTableFrameStartDayEditBox:SetText( date("%d", ref[1][1]) );
	HKCTableFrameStartYearEditBox:SetText( date("%y", ref[1][1]) );
	HKCTableFrameStartHourEditBox:SetText( date("%H", ref[1][1]) );
	HKCTableFrameEndMonthEditBox:SetText( date("%m", ref[table.getn(ref)][1]) );
	HKCTableFrameEndDayEditBox:SetText( date("%d", ref[table.getn(ref)][1]) );
	HKCTableFrameEndYearEditBox:SetText( date("%y", ref[table.getn(ref)][1]) );
	HKCTableFrameEndHourEditBox:SetText( date("%H", ref[table.getn(ref)][1]) + 1 );

	HKCTableFrame_UpdateDB();

	HKCTableFrame_Update();
end

function HKCTableFrame_Update()
	local offset = FauxScrollFrame_GetOffset(HKCTableFrameScrollBar);

	HKCTableFrame_DrawTable(HKC_DB, offset);
	local items = table.getn(HKC_DB);
	local i;

	if ( items <= 20 ) then
		HKCTableFrameScrollBar:Hide();
	else
		HKCTableFrameScrollBar:Show();
	end

	FauxScrollFrame_Update(HKCTableFrameScrollBar, items, 20, 12 );
end

function HKCTableFrame_Sort(type)

	if ( HKC_LastSort == type ) then
		table.sort(HKC_DB, 
			function(a, b)
				local x, y = a[type], b[type];
				if ( not x ) then
					x = 0;
				end
				if ( not y ) then
					y = 0;
				end

				return x < y;
			end
		);
		HKC_LastSort = 0;
	else
		table.sort(HKC_DB, 
			function(a, b)
				local x, y = a[type], b[type];
				if ( not x ) then
					x = 0;
				end
				if ( not y ) then
					y = 0;
				end

				return x > y;
			end
		);
		HKC_LastSort = type;
	end

end

function HKCTableFrameAllRecordsCheckButton_OnClick(self)
	if (self:GetChecked()) then
		HKCTableFrameStartMonthEditBox:Hide();
		HKCTableFrameStartDayEditBox:Hide();
		HKCTableFrameStartYearEditBox:Hide();
		HKCTableFrameStartHourEditBox:Hide();
		HKCTableFrameEndMonthEditBox:Hide();
		HKCTableFrameEndDayEditBox:Hide();
		HKCTableFrameEndYearEditBox:Hide();
		HKCTableFrameEndHourEditBox:Hide();
		HKCTableFrameTo:Hide();
	else
		HKCTableFrameStartMonthEditBox:Show();
		HKCTableFrameStartDayEditBox:Show();
		HKCTableFrameStartYearEditBox:Show();
		HKCTableFrameStartHourEditBox:Show();
		HKCTableFrameEndMonthEditBox:Show();
		HKCTableFrameEndDayEditBox:Show();
		HKCTableFrameEndYearEditBox:Show();
		HKCTableFrameEndHourEditBox:Show();
		HKCTableFrameTo:Show();
	end

	HKCTableFrame_UpdateDB();
	HKCTableFrame_Update();
end

function HKCTableFrameTimeFrameEditBoxes_SetTimeFrame(self)
	self:HighlightText(0, 0);
	HKCTableFrame_UpdateDB();
	HKCTableFrame_Update();
end

function HKCFrameFiltersButton_OnClick(self)
	if ( HKCFilterFrame:IsVisible() ) then
		self:SetText(FILTERS.." >>>");
		HKCFilterFrame:Hide();
	else
		self:SetText(FILTERS.." <<<");
		HKCFilterFrame:Show();
	end
end

function HKCFilterFrame_OptionClicked(self, check)
	HKCTableFrame_UpdateDB();
	HKCTableFrame_Update();
	if ( check ) then
		if ( self:GetChecked() ) then
			PlaySound("igMainMenuOptionCheckBoxOn");
		else
			PlaySound("igMainMenuOptionCheckBoxOff");
		end
	end
end
